void drawXLabels()
{
  fill(255);
  textAlign(CENTER, TOP);
  
  // Use thin, gray lines to draw the grid
  stroke(255,120);
  strokeWeight(2);


  for (int row = 0; row <= XMAX; row++) {
    if (row % XINTERVAL == 0) {
      float x = map(row, XMIN, XMAX, PLOTX1, PLOTX2);
      textFont(font); 
      textAlign(CENTER, CENTER);         // Center vertically
      fill(255);
      text(row, x, PLOTY2 + 15,PLOTZ1);
      strokeWeight(2); 
      line(x, PLOTY1,PLOTZ1, x, PLOTY2+5,PLOTZ1);

    }
  }

}

void drawYLabels()
{
  fill(255);
  textFont(font); 
  stroke(255);
  strokeWeight(2); 
  for (float v = DATAMIN; v <= DATAMAX; v += YINTERVAL) {
    if (v % YINTERVAL == 0) {     // If a tick mark
      float y = map(v, DATAMAX, DATAMIN, PLOTY2, PLOTY1);  
      if (v % YINTERVAL == 0) {        // If a major tick mark
        textAlign(RIGHT, CENTER);         // Center vertically
        text(floor(v), PLOTX1 - 10, y,PLOTZ1);
        line(PLOTX1 - 4, y, PLOTZ1, PLOTX1, y,PLOTZ1);     // Draw major tick
      } else {
        line(PLOTX1 - 2, y, PLOTZ1, PLOTX1, y,PLOTZ1);   // Draw minor tick
      }
    }
  }
}

void drawZLabels()
{
  fill(255);
  textFont(font); 
  stroke(255);
  strokeWeight(2); 

  for (float v = DATAMINZ; v <= DATAMAXZ; v += ZINTERVAL) {
    if (v % ZINTERVAL == 0) {     // If a tick mark
      float z = map(v, DATAMAXZ, DATAMINZ, PLOTZ2, PLOTZ1);  
      if (z % ZINTERVAL == 0) {        // If a major tick mark
        textAlign(RIGHT, CENTER);         // Center vertically
        text(floor(z), PLOTX1 - 15, PLOTY1, z);
        line(PLOTX1 - 8, PLOTY1 , z, PLOTX1, PLOTY1, z);     // Draw major tick
      } 
    }
  }
}



void drawGrid()
{
  stroke(255); 
  strokeWeight(1); 
  for(int i = PLOTX1; i <= PLOTX2; i = i + gridInterval)
  {
    line(i,PLOTY1,PLOTZ1, i,PLOTY2,PLOTZ1);      
    for(int k = PLOTY1; k <= PLOTY2; k = k + gridInterval)
    {
      line(PLOTX1,k,PLOTZ1,PLOTX2,k,PLOTZ1);
    }   
  }  
}

void drawPlot()
{
  noStroke();
  fill(93,186,255,120); 
  rectMode(CORNERS);
  pushMatrix(); 
  translate(0,0,PLOTZ1);
  rect(PLOTX1,PLOTY1,PLOTX2,PLOTY2); 
  popMatrix(); 
}

void drawAxisLabels() 
{
  fill(255);
  textLeading(15);
  textFont(font);  
  pushMatrix();
  translate(0,0,PLOTZ1);
  textAlign(CENTER, CENTER);
  // Use \n (enter/linefeed) to break the text into separate lines
  text("X-AXIS\nLABEL", (PLOTX1+PLOTX2)/2, PLOTY2+160);
  textAlign(CENTER, CENTER);
  text("Y-AXIS\nLABEL", PLOTX1-200, (PLOTY1+PLOTY2)/2);
  popMatrix(); 
  text("Z-AXIS\nLABEL", PLOTX1-160,PLOTY1, (PLOTZ1+PLOTZ2)/2 );
  textAlign(CENTER, CENTER);

}

void drawTitle() {
  fill(255);
  textAlign(LEFT);
  textFont(font);
  pushMatrix(); 
  translate(0,0,PLOTZ1);
  text("SPL DATA VISUALIZATION", PLOTX1, PLOTY1 - 10);
  textAlign(RIGHT);
  text("MAT 259", PLOTX2, PLOTY1 - 10);  
  popMatrix(); 
}




